Codeforces Round 884 (Div. 1 + Div. 2)(A~D)

2023-11-02 19:53
文章标签 codeforces round div 884

本文主要是介绍Codeforces Round 884 (Div. 1 + Div. 2)(A~D),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

目录

A. Subtraction Game

题目分析:

B. Permutations & Primes 

题目分析:

C. Particles

题目分析: 

 D. Row Major

题目分析:


A. Subtraction Game

题目分析:

给两个数a,b,每次都必须取其中的一个,谁没东西可取谁输,取求后手必胜策略, 直接输出a+b即可,因为无论先手拿a和b当中的哪一个,后手会拿走另一个,后手必胜。

#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define INF 0x3f3f3f3f
#define IOS ios::sync_with_stdio(false);cin.tie(0);
#define int long long
#define pb push_back
#define vct vector
#define checkbit __builtin_popcount
#define gcd __gcd
#define use int T;cin>>T;while(T--)
template<class T> bool mmax(T &u, T v) { return u < v ? (u = v, 1) : 0; }
template<class T> bool mmin(T &u, T v) { return u > v ? (u = v, 1) : 0; }
#define lowbit(x) (x&(-x))
#define yes cout<<"YES"<<endl
#define no cout<<"NO"<<endl
using namespace std;
typedef pair<int,int>pii;
signed main()
{IOS
use{int a,b;cin>>a>>b;cout<<(a+b)<<endl;
}
return 0;
}

B. Permutations & Primes 

题目分析:

给定一个n个数的数组,即从1~n,问如何排列该数组,使MEX能得到素数的子序列最多,MEX为序列当中未出现的最小正整数,如果某个序列不包含1,那么这个序列就是无用序列,因为1并不是素数,所以1应该放在中间,使得能取到1的子序列尽可能的多,对于第二和第三小的数,也就是2和3,它们本身是素数,所以应该放到数组的两侧,使得能取到他俩的子序列尽可能的少。这样可以得到最优解

#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define INF 0x3f3f3f3f
#define IOS ios::sync_with_stdio(false);cin.tie(0);
#define int long long
#define pb push_back
#define vct vector
#define checkbit __builtin_popcount
#define gcd __gcd
#define use int T;cin>>T;while(T--)
template<class T> bool mmax(T &u, T v) { return u < v ? (u = v, 1) : 0; }
template<class T> bool mmin(T &u, T v) { return u > v ? (u = v, 1) : 0; }
#define lowbit(x) (x&(-x))
#define yes cout<<"YES"<<endl
#define no cout<<"NO"<<endl
using namespace std;
typedef pair<int,int>pii;
signed main()
{IOS
use{int n;cin>>n;if(n==2)cout<<"1 2"<<endl;else if(n==1)cout<<"1"<<endl;else if(n==3)cout<<"3 1 2"<<endl;else if(n==4)cout<<"3 4 1 2"<<endl;else{n-=3;cout<<"2 ";int start=3;for(int i=1;i<=n;i++){cout<<start+i<<" ";if(i==n/2) cout<<"1 ";}cout<<"3"<<endl;}
}
return 0;
}

C. Particles

题目分析: 

一堆数,可以抽离两数之间的数使得两数加和,通过模拟可知,如果两数相隔球的数量为奇数,那么二球可以合并,否则不行,那么问题其实就化简为了求 奇数位数的和 还有 偶数位数的和取二者最大值,负数对于最终答案的贡献是负的,所以忽略负数。

#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define INF 0x3f3f3f3f
#define IOS ios::sync_with_stdio(false);cin.tie(0);
#define int long long
#define pb push_back
#define vct vector
#define checkbit __builtin_popcount
#define gcd __gcd
#define use int T;cin>>T;while(T--)
template<class T> bool mmax(T &u, T v) { return u < v ? (u = v, 1) : 0; }
template<class T> bool mmin(T &u, T v) { return u > v ? (u = v, 1) : 0; }
#define lowbit(x) (x&(-x))
#define yes cout<<"YES"<<endl
#define no cout<<"NO"<<endl
using namespace std;
typedef pair<int,int>pii;
signed main()
{IOS
use{int n;cin>>n;vct<int>a(n+1);int mins=-1e9-100;bool st=0;for(int i=1;i<=n;i++){cin>>a[i];if(a[i]>0)st=1;mmax(mins,a[i]);}if(st){int ans1=0;for(int i=1;i<=n;i+=2){if(a[i]>0)ans1+=a[i];}int ans2=0;for(int i=2;i<=n;i+=2){if(a[i]>0)ans2+=a[i];}cout<<1ll*max(ans1,ans2)<<endl;}else cout<<mins<<endl;
}
return 0;
}

 D. Row Major

题目分析:

要求输出一个长度为n的字符串,根据字符串的长度,可以分成其两个因数组成的矩形,例如n为6的时候有这几种情况:

 对于奇数,那么其只能构成横排或者竖排,只需要相邻两个字符不重复即可。

对于偶数,我们需要找到字符串长度n的非因数,因为矩形的长宽均由因数组成,所以只要确保由非因数长度的字符组成的字符串内部不重复,就可以保证满足条件,而题目又说使得整个字符串当中不同字符的个数尽可能的少,所以只要找出最小的那个非因数即可。

如果出现最小的非因数大于26怎么办?这样不就导致字符串重复了?需要明白的是,如果最小非因数大于26,说明这个数至少是26!(403291461126605635584000000),故一定不会出现重复情况.

#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define INF 0x3f3f3f3f
#define IOS ios::sync_with_stdio(false);cin.tie(0);
#define int long long
#define pb push_back
#define vct vector
#define checkbit __builtin_popcount
#define gcd __gcd
#define use int T;cin>>T;while(T--)
template<class T> bool mmax(T &u, T v) { return u < v ? (u = v, 1) : 0; }
template<class T> bool mmin(T &u, T v) { return u > v ? (u = v, 1) : 0; }
#define lowbit(x) (x&(-x))
#define yes cout<<"YES"<<endl
#define no cout<<"NO"<<endl
using namespace std;
typedef pair<int,int>pii;
signed main()
{IOS
use{int n;cin>>n;if(n%2){for(int i=1;i<=n;i++){if(i%2)cout<<'a';else cout<<'b';}cout<<endl;}else {int x=2;for(;x;x++){if(n%x!=0)break;}for(int i=1;i<=n;i++){cout<<(char)(i%x+'a');}cout<<endl;}
}
return 0;
}

 

这篇关于Codeforces Round 884 (Div. 1 + Div. 2)(A~D)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/332932

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There